#!/usr/bin/perl

# Script to generate accounting baseline.
# Written 2012-12-21 by Jim Lippard.

### Requirements.
use strict;

### Constants.
my $ACCOLLECT = '/usr/local/bin/accollect.pl';
my $ACSTATS = '/usr/local/bin/acstats.pl';
my $LASTCOMM = '/usr/bin/lastcomm';
my $MKTEMP = '/usr/bin/mktemp';

my $USERNAME = $ENV{'LOGNAME'} || $ENV{'USER'} || 'lippard';

my $LAST_RUNTIME_FILE = "/home/$USERNAME/stats/acct_monitor.last";

my $ACCT_FILE = '/var/account/acct';
my $MAX_ACCT_FILE = 3;

### Variables.
my ($tmpfile, $idx, $last_runtime, $account_file);

### Program.
$tmpfile = `$MKTEMP -q /tmp/acct_baseline.XXXXXXX`;
chop ($tmpfile);

open (TEMP, ">$tmpfile") || die "Cannot open $tmpfile. $!\n";
for ($idx = $MAX_ACCT_FILE; $idx >= -1; $idx--) {
    if ($idx >= 0) {
	$account_file = $ACCT_FILE . '.' . $idx;
    }
    else {
	$account_file = $ACCT_FILE;
    }

    open (LASTCOMM, "$LASTCOMM -f $account_file |") || die "Cannot open $account_file with $LASTCOMM. $!\n";
    while (<LASTCOMM>) {
	print TEMP $_;
    }
    close (LASTCOMM);
}
close (TEMP);

open (FILE, ">$LAST_RUNTIME_FILE") || die "Could not open file $LAST_RUNTIME_FILE for writing. $!\n";
$last_runtime = time();
print FILE "$last_runtime";
print FILE "\n";
close (FILE);

open (TEMP, "$tmpfile") || die "Cannot open $tmpfile for reading. $!\n";
open (ACCT_COLLECT, "| $ACCOLLECT") || die "Cannot open $ACCOLLECT. $!\n";
while (<TEMP>) {
    print ACCT_COLLECT $_;
}
close (ACCT_COLLECT);
close (TEMP);

unlink ($tmpfile);

system "$ACSTATS";
